import {
  useLimeplay
} from "./chunk-WUIGF72E.mjs";

// src/hooks/useShakaPlayer.ts
import { useEffect, useState } from "react";
import shaka from "shaka-player";
function useShakaPlayer() {
  const { playback, setPlayer } = useLimeplay();
  const [error, setError] = useState(null);
  const [isLoaded, setIsLoaded] = useState(false);
  useEffect(() => {
    let _player = null;
    const errorHandler = (event) => setError(event);
    if (playback) {
      console.log("[ useShakaPlayer ] - Creating new player ");
      _player = new shaka.Player(playback);
      _player.addEventListener("error", errorHandler);
      setPlayer(_player);
      setIsLoaded(true);
    }
    return () => {
      setIsLoaded(false);
      setError(null);
      if (_player) {
        _player.removeEventListener("error", errorHandler);
        _player.destroy();
        setPlayer(null);
      }
    };
  }, [playback]);
  return {
    error,
    isLoaded
  };
}

export {
  useShakaPlayer
};
